/* program to find what filesystem a file is mounted on */
#include <stdio.h>
#include <mntent.h>
#include <sys/types.h>
#include <sys/vfs.h>

#define FSIDS 100
int fss;
fsid_t fsid[FSIDS];
char dir[FSIDS][100];

panic(s)
  char *s;
{
    puts (s);
    exit(-1);
}

initialize()
{
    struct statfs s;
    struct mntent *m;
    FILE *f = setmntent("/etc/mtab", "r");

    if (!f) panic("Couldn't open /etc/mtab.\n");
    while ((m = getmntent(f))) {
	if (sizeof(dir[0]) <= strlen(m->mnt_dir))
	  panic("Name to long.\n");
	strcpy(dir[fss], m->mnt_dir);
	if (statfs(m->mnt_dir, &s) < 0)
	  panic("Could not get filesystem stats.\n");
	if (FSIDS <= fss) panic ("File table is too big.\n");
	fsid[fss++] = s.f_fsid;
    }
    endmntent(f);
}

char *file_system_name(f) char *f;
{
    int i;
    struct statfs s;

    if (statfs(f, &s) < 0)
      puts ("Could not find stats on file.\n");

    for (i=0; i<fss; ++i)
      if (   fsid[i].val[0] == s.f_fsid.val[0]
	  && fsid[i].val[1] == s.f_fsid.val[1]
	  )
	return dir[i];
    puts ("Could not file filesystem in list.\n");
    return 0;
}

main(argc, argv) char **argv;
{
    initialize();
    while (*++argv) {
	printf ("%s  \t",  *argv);
	printf("%s\n", file_system_name(*argv));
    }
    return 0;
}
