/* multiple file rename utility */
/* this program takes multiple files and gives them a new name,
   preserving extensions. e.g.:
   dir:		foo.c foo.h foo.c.~1~
   rename foo.* bar
   yeilds:	bar.c bar.h bar.c.~1~

   If you specify '-' as the first argument, rename will simply display
   what it would do, but not do it.
   */

/* 20-Jun-88 Dan Christian	written */

#include <stdio.h>

main (argc, argv)
  int argc;
  char **argv;
{
    int i, test;
    char *cp, *tail;
    char *new, *prog;
    char from[128], to[128];

    prog = argv[0];

    new = argv [argc-1];

    i = 1;
    test = 0;
    if (argv[i][0] == '-') {
	test = 1;
	i++;
    }
    if ((argc - i) < 2) {
	fprintf (stderr, "%s: At least two arguments are needed.\n", prog);
	exit (1);
    }

    for (; i < argc -1; i++) {
	for (cp = argv[i]; *cp; cp++); /* go to the end */
	tail = cp;
	for (cp--; (cp >= argv[i]) && (*cp != '/'); cp--)
	  if (*cp == '.') tail = cp;
	      
	sprintf (from, "%s", argv[i]); /* from */
	if (*cp == '/') {
	    *cp = 0;
	    sprintf (to,"%s/%s%s", argv[i], new, tail);
	} else {
	    sprintf (to, "%s%s", new, tail);
	}
	if (test) {
	    printf ("From <%s> to <%s>\n", from, to);
	} else {
	    rename (from, to);
	}
    }
}
