/* nifty little plotting program that does autoscaling. */
/* created by Dan Christian 1-21-88 */

#include <stdio.h>
#include <dos.h>
#include <stdlib.h>
#include <math.h>
#include <float.h>

#define MAX(x,y)	((x) > (y) ? (x) : (y))
#define MIN(x,y)	((x) < (y) ? (x) : (y))
#define DEF -99997

char wait_key();

char in_buff[128];
int line_cnt;

int by_twos, point_cnt;
int width= 639, height= 199;	/* pc defaults */
int cx, cy;
float *datx=NULL;
float daty[2000];
float x_min, y_min, x_max, y_max;
float scale_x, scale_y;
float x_low, y_low, x_up, y_up;

char far *screen;		/* for writing to the screen */
char far *romfont;
char mask[8] = { 128, 64, 32, 16, 8, 4, 2, 1 };

init()				/* reset most globals */
{
    romfont = (char far *)((long)0xf000<<16 + (long)0xfa6e);
    screen = (char far *)((long)0x00b800<<16);

    by_twos = 0;
    x_min = y_min = 99999;
    x_max = y_max = -99999;
    x_low = y_low = x_up = y_up = DEF;
}

graphicsmd()			/* put screen into high res mode. */
{
    union REGS srv;
    srv.x.ax = 0x0006;		/* mode 6: 640x200 monochrome */
    int86(0x10,&srv,&srv);
}

textmd()			/* return to 80x25 mode */
{
    union REGS srv;

    srv.x.ax = 0x0002;
    int86(0x10,&srv,&srv);
}

char wait_key ()		/* wait for a key press and return it */
{
    while (! (char) bdos (0xB, 0, 0));
    return (getchar());
}

plotc(x,y, c)			/* writes chars into CGA in mode 6 */
  int x,y;
  char c;
{
    int row, id=c;
    
    if ((x<0) || (y<0) || (x>width-8) || (y>height-8)) return; /* clip */

    id -= ' ';			/* shift to printables */
    id <<=3;			/* multiply by 8 */
    x >>= 3;			/* divide by 8 */

    for (row = y; row < y + 8; row++) {
	if (y&1)
	  screen[(y>>1)*80+x+0x2000] = romfont[id++];
	else
	  screen[(y>>1)*80+x] = romfont[id++];
	}
}

plots (x,y,s)			/* print strings to screen */
  int x,y;			/* doesnt work */
  char *s;

{
    graphicsmd();
    while (*s)
      plotc (x,y,*s++);
    wait_key();
    textmd();
}

point(x,y)			/* writes into CGA in mode 6 */
  int x,y;
{
    int a;
    
    if ((x<0) || (y<0) || (x>width) || (y>height)) return; /* clip */

    if (y&1)
      screen[(y>>1)*80+x/8+0x2000] |= mask[x&7];
    else
      screen[(y>>1)*80+x/8] |= mask[x&7];
}

line (x1,y1, x2, y2)		/* Bresenhams algorythme */
  register int x1,y1;
  int x2,y2;		/* from C the complete reference p 650 */
{
    register int t, distance;
    int xerr=0, yerr=0;
    int incx, incy;
    int delta_x, delta_y;

    delta_x = x2-x1;
    delta_y = y2-y1;

    /* find direction of increment */
    if (delta_x > 0)
      incx = 1;
    else {
	if (delta_x == 0)
	  incx = 0;
	else 
	  incx = -1;
    }

    if (delta_y > 0)
      incy = 1;
    else {
	if (delta_y == 0)
	  incy = 0;
	else 
	  incy = -1;
    }

    delta_x = abs (delta_x);
    delta_y = abs (delta_y);
    distance = MAX (delta_x, delta_y);

    for (t=0; t <= distance+1; t++) {
	point (x1,y1);
	xerr += delta_x;
	yerr += delta_y;
	if (xerr > distance) {
	    xerr -= distance;
	    x1 += incx;
	}
	if (yerr > distance) {
	    yerr -= distance;
	    y1 += incy;
	}
    }
}

				/* dotted lines: every freqth point */
dot_line (x1,y1, x2, y2, freq)	/* Bresenhams algorythme */
  register int x1,y1;
  int x2,y2, freq;		/* freq will be rounded to > 0 */
{
    register int t, distance;
    int xerr=0, yerr=0;
    int incx, incy;
    int delta_x, delta_y;
    int pnts =0;

    if (freq <= 0) freq = 1;	/* round up to continuous */

    delta_x = x2 - x1;
    delta_y = y2 - y1;

    /* find direction of increment */
    if (delta_x > 0)
      incx = 1;
    else {
	if (delta_x == 0)
	  incx = 0;
	else 
	  incx = -1;
    }

    if (delta_y > 0)
      incy = 1;
    else {
	if (delta_y == 0)
	  incy = 0;
	else 
	  incy = -1;
    }

    delta_x = abs (delta_x);
    delta_y = abs (delta_y);
    distance = MAX (delta_x, delta_y);

    for (t=0; t <= distance+1; t++) {
	if (!pnts) point (x1,y1);
	pnts = ++pnts % freq;
	xerr += delta_x;
	yerr += delta_y;
	if (xerr > distance) {
	    xerr -= distance;
	    x1 += incx;
	}
	if (yerr > distance) {
	    yerr -= distance;
	    y1 += incy;
	}
    }
}

show_error (mess, a, b, c, d, e)
  char *mess;
  char *a, *b, *c, *d, *e;	/* arguments to printf */
{
    fprintf (stderr, "Error on line: %d: \t%s\n",
	     line_cnt, mess, a, b, c, d, e);
    fprintf (stderr, "%s\n", in_buff);
}

/* draw inteligently placed axis and a hash mark grid */
draw_axis(xmax, xmin, ymax, ymin, xstep, ystep)
  double xmax, xmin, ymax, ymin, xstep, ystep;
{
    double z, scx, scy;

    scx = 1.0 / (xmax - xmin);
    scy = 1.0 / (ymax - ymin);

    if ((xmin <= 0) && (xmax) >= 0) /* x axis placement */
      cx = (int) ((0.0 - xmin) * scx * width);
    else if (xmin > 0)		/* off screen to the left use 0 */
      cx = 0;
    else if (xmax < 0)		/* off screen to the right use width */
      cx = width;

    line (cx, 0, cx, height);

    if ((ymin <= 0) && (ymax) >= 0) /* y axis placement */
      cy = (int)((1.0 + ymin * scy) * height);
    else if (ymin > 0)		/* off bottom of screen */
      cy = height;
    else if (ymax < 0)		/* off top of screen */
      cy = 0;

    line (0, cy, width, cy);

    /* print hash lines */
    for (z = xmin; z <= xmax; z += xstep) { /* draw X hash marks */
	dot_line ((int)((z-xmin) * scx * width), 0,
		  (int)((z-xmin) * scx * width), height, 4);
    }

    for (z = ymin; z <= ymax; z += ystep) {
	dot_line (0, (int)((1 - (z - ymin) * scy) * height),
		   width, (int)((1 - (z - ymin) * scy) * height), 4);
    }
}

/* make intelligent axis choises and plot data */
plot_it()			/* won't do by_twos plotting yet. */
{
    int i, lx, ly, cx, cy;
    double z, x_step, y_step, x_lo, x_hi, y_lo, y_hi;

    if (x_low != DEF) x_min = x_low; /* use commanded lows and his */
    if (x_up != DEF) x_max = x_up;

    y_max = -99999;
    y_min = 99999;
    if ((y_up == DEF) || (y_low == DEF))
      for (i = x_min; i <= x_max; i++) { /* only works for by ones plotting */
	  y_max = MAX (daty[i], y_max);
	  y_min = MIN (daty[i], y_min);
      }
    if (y_up != DEF) y_max = y_up;
    if (y_low != DEF) y_min = y_low;

    printf ("X data range: %g %g\n", x_min, x_max);
    printf ("Y data range: %g %g\n", y_min, y_max);

				/* do really nifty intelligent scaling */
    if ((x_max - x_min) < 10e-10) {
	printf ("Data range is too small to plot (no data?)\n");
	wait_key();
	return;
    }
    /* order of magnitude of range to give 10 steps */
    x_step = (pow (10.0,
		   ceil (log ((double)(x_max - x_min)) / log (10.0)))) / 10.0;
    if (((double)(x_max - x_min) / x_step) < 3.0) {
	x_step /= 5.0;		/* display at least 3 devisions */
    }

    x_lo = x_step * floor ((double)x_min / x_step);
    x_hi  = x_step * ceil ((double)x_max / x_step);

    if ((y_max - y_min) < 10e-10) {
	y_max += .1;
	y_min -= .1;
/*	printf ("Data range is too small to plot (no data?)\n");
	wait_key();
	return;*/
    }
    y_step = (pow (10.0,
		   ceil (log ((double)(y_max - y_min)) / log (10.0)))) / 10.0;
    if (((double)(y_max - y_min) / y_step) < 3.0) {
	y_step /= 5.0;
    }

    y_lo = y_step * floor ((double)y_min / y_step);
    y_hi  = y_step * ceil ((double)y_max / y_step);

    printf ("X display range %g  %g  \tstep %g\n", x_lo, x_hi, x_step);
    printf ("Y display range %g  %g  \tstep %g\n", y_lo, y_hi, y_step);
    printf ("press RETURN to see plot\n");
    scale_x = 1.0 / (x_hi - x_lo);
    scale_y = 1.0 / (y_hi - y_lo);

    wait_key();

    graphicsmd();
    draw_axis(x_hi, x_lo, y_hi, y_lo, x_step, y_step);

    lx = (int)((float)(x_min - x_lo) * scale_x * width);
    ly = (int)((1 - (daty[(int)x_min] - y_lo) * scale_y) * height);
    for (i = x_min + 1; i <= x_max; i++) { /* only for by ones plotting */
	cx = (int)((i - x_lo) * scale_x * width);
	cy = (int)((1 - (daty[i] - y_lo) * scale_y) * height);

	line (lx, ly, cx, cy);
	lx = cx; ly = cy;
    }
    wait_key();
    textmd();
}

/* top level of plotting loop */
plot (fin, fout, prompt)	/* read in numbers, then graph them */
  FILE *fin, *fout;
  char *prompt;
{
    char *clean;
    short chrs;
    int flags = 0;
    float val1, val2;

    line_cnt = 0;		/* reset system line counter */
    point_cnt = 0;
    x_min = 0;			/* unless switched to by_twos */

    while (! feof (fin)) {
	if (fout) fputs (prompt, fout);	/* fout may be NULL */
	if (fgets (in_buff, 128, fin) == NULL) break;
	line_cnt++;

	for (clean = in_buff;	/* skip initial whitespace */
	     (*clean) && ((*clean  == ' ') || (*clean == '\t'));
	     clean++);

	if (((clean[0] >= '0') && (clean[0] <= '9')) || (clean[0] == '-')) {
	    if (by_twos) {
		if (sscanf (clean, "%f %f", &val1, &val2) != 2) {
		    show_error ("Could not read 2 values.\n");
		}
		datx[point_cnt] = val1;
		daty[point_cnt++] = val2;
		x_max = MAX (val1, x_max);
		x_min = MIN (val1, x_min);
		y_max = MAX (val2, y_max);
		y_min = MIN (val2, y_min);
	    } else {
		if (1 == sscanf (clean, "%f", &val1)) {
		    daty[point_cnt] = val1;
		    x_max = point_cnt++;
		} else {
		    show_error ("Could not read a number\n");
		}
	    }
	} else parameters (clean, fout);
    }
    plot_it();
}

parameters (buff, fout)		/* process commands to plot */
  char *buff;
  FILE *fout;
{
    switch (buff[0]) {

      case 'i':		/* re init */
      case 'I':
	init ();
	break;

      case 'l':		/* set lower limits */
      case 'L':
	switch (buff[1]) {
	  case 'x':
	  case 'X':
	    sscanf (&buff[2], "%f", &x_low);
	    break;
	    
	  case 'y':
	  case 'Y':
	    sscanf (&buff[2], "%f", &y_low);
	    break;
	    
	  default:
	    show_error ;("Error setting low. must be lx or ly\n");
	}
	break;
	
      case 'p':		/* plot it */
      case 'P':
      case EOF:
	plot_it ();
	break;

      case 'q':
      case 'Q':
	exit(0);

      case 'r':			/* read in another file */
      case 'R':
	open_and_plot (&buff[1]);
	break;

      case 't':
	plots (100, 100, &buff[1]);
	plots (20, 20, &buff[1]);
	break;

      case 'u':		/* set upper limits */
      case 'U':
	switch (buff[1]) {
	  case 'x':
	  case 'X':
	    sscanf (&buff[2], "%f", &x_up);
	    break;
	    
	  case 'y':
	  case 'Y':
	    sscanf (&buff[2], "%f", &y_up);
	    break;
	    
	  default:
	    show_error ("Error setting upper. must be ux or uy\n");
	}
	break;

      case '#':
	printf (&buff[1]);
	break;

      case ';':			/* comments */
      case  0:			/* empty line */
      case '\n':		/* empty line */
	break;

      case 'H':
      case 'h':
      case '?':
	printf ("Commands are:\n");
	printf ("lx,ly \tset lower x/y bounds\n");
	printf ("ux,uy \tset upper x/y bounds\n");
	printf ("p \tplot data\n");
	printf ("r \tread and plot a file\n");
	printf ("# \techo line\n");
	printf ("; \tcomment lines\n");
	printf ("i \tre initialize Super plot\n");
	printf ("h \tprint this help listing\n");
	printf ("q \tquit Super Plot\n");
	break;

      default:
	show_error ("Unknown command.\n");
	break;
    }
}

open_and_plot (nm)		/* open a file, then call plot */
  char *nm;
{
    FILE *in;
    char tmp[80], *tp;
    char *clean, *tail;

    for (clean = nm;		/* skip initial whitespace */
	 (*clean) && ((*clean  == ' ') || (*clean == '\t'));
	 clean++);
    tp = tmp;			/* copy into tmp buffer */
    for (tail = clean;
	 (*tail) && (*tail != ' ') && (*tail != '\t') && (*tail != '\n');
	 tail)
      *tp++ = *tail++;
    *tp = 0;			/* force null terminate */

    in = fopen (tmp, "r");
    if (! in) {
	printf ("Could not open file: %s\n", tmp);
	return;
    }
    init();
    plot (in, stderr, "");
    close (in);
}

main (argc, argv)
  int argc;
  char **argv;
{
    init();
    if (argc == 1)  {		/* run interactively */
	plot (stdin, stdout, ";-) ");
    } else 
      while (--argc) {		/* parse command line */
	  ++argv;
	  if (**argv == '-') {	/* pass arguments to parameters */
	      parameters (&(*argv[1]), stderr);
	  } else {
	      open_and_plot (*argv);
	  }
      }
    textmd();
}
