
typedef struct _DEVICEe {
    DEVICE	dev_id;		/* individual unique id */
    Ushort	conn_drv;	/* communication device driver ID */
    BITFLAG	able;		/* bit flag of abilities */
    long 	data1;		/* additional connection data */
    long	data2;
    long	data3;
} DEVICEe;
/* flags for able, other flags are the same as open flags. */
#define  DEV_DATA	0x40000000 /* flag additional data is valid */

/* this structure is assumed to seldom change.  That is why a single lock
   is used*/
typedef struct {
    volatile int key;		/* shared memory key */
    DEVICE	local_host;	/* my device id */
    Ulong	*my_offset;	/* my offset on the buss */
    HOST_MAP	*host_map;	/* my host table */
    DEVICE_MAP	*dev_map;	/* the system device table */
    ACCEPT_MAP	*acc_map;	/* map of process waiting for connections */
				/* acc_map must not move in memory */
    DEVICEe	**dev_tbl;	/* table of devices */
    int		dev_tbl_sz;	/* size of dev_tbl (max entries) */
    DRIVERe	**drv_tbl;	/* table of drivers*/
    int		drv_tbl_sz;	/* size of drv-tbl (max entries) */
    MSG_POOL	**malloc_tbl;	/* table of malloc pools */
    int		malloc_tbl_sz;
} HOST_DEF;

extern HOST_DEF	dtic_host_def;	/* pointers to host info */

#ifdef ANSI
extern DEVICEe *get_dev_entry (DEVICE dev);
extern DRIVERe *get_driver_entry (DEVICE drv);

#else ANSI
extern DEVICEe *get_dev_entry ();
extern DRIVERe *get_driver_entry ();
#endif ANSI

#endif DTIC_SYS_READ
